<!--
 * @Title: 
 * @Description: 
 * @Author: 893699165@qq.com
 * @Date: 2022-08-24 10:49:21
 * @LastEditors: 
 * @LastEditTime: 2022-08-24 10:49:21
-->
<template>
    <div>
        <el-row>
            <!-- <el-col :span="5">
        <div class="box">
          <el-scrollbar>
          <basic-container>
            <avue-tree
              :option="treeOption"
              :data="treeData"
              @node-click="nodeClick"
            />
          </basic-container>
        </el-scrollbar>
        </div>
      </el-col> -->
            <el-col :span="24">
                <basic-container>
                    <avue-crud :option="option" :table-loading="loading" :data="data" :page.sync="page"
                        :before-open="beforeOpen" ref="crud" v-model="form" :permission="permissionList"
                        @row-del="rowDel" @row-update="rowUpdate" @row-save="rowSave" @search-change="searchChange"
                        @search-reset="searchReset" @selection-change="selectionChange" @current-change="currentChange"
                        @size-change="sizeChange" @refresh-change="refreshChange" @on-load="onLoad"
                        @before-open="beforeOpen">
                        <template slot="state" slot-scope="{ row }">
                            <el-button type="text" @click="openConfig(row)"> 正常 </el-button>
                        </template>
                        <template slot-scope="{ row, index }" slot="menu">

                            <el-button type="text" size="small" @click="rtuImport(row)">导入测站
                            </el-button>

                        </template>
                    </avue-crud>
                </basic-container>
            </el-col>
        </el-row>

        <el-dialog title="导入向导" :visible.sync="rtuImportProcessDialog" width="60%" height="60%"
            :close-on-click-modal="false" append-to-body :v-loading="importLoading" v-if="rtuImportProcessDialog">
            <rtuImportProcess :id="projectId" :projectName="projectName" :importLoading="importLoading"
                :visible.sync="rtuImportProcessDialog" ref="rtuImportProcess"></rtuImportProcess>
        </el-dialog>

    </div>
</template>

<script>
import { getPage, getDetail, add, update, remove } from "@/api/baseinfo/project";
// import { mapGetters } from "vuex";
//   import warningInfo from "./warningInfo.vue";
//   import maintainOrder from "./maintainOrder.vue";
import {
    getDeptTree,
} from "@/api/system/dept.js";
import { getToken } from "@/util/auth";
// import { dateFormat } from "@/util/date";
import rtuImportProcess from "./rtuImportProcess.vue";
export default {
    components: {
        rtuImportProcess,

    },
    data() {
        return {
            importLoading: false,
            loading: false,
            rtuImportProcessDialog: false,
            warningConfig: {
                configSw: false,
                code: "",
            },
            infoDialog: false,
            rtuImportDialog: false,

            projectId: 0,
            projectName: '',

            id: "",
            editForm: {},
            editDialog: false,
            form: {},
            selectionList: [],
            query: {},

            page: {
                pageSize: 10,
                currentPage: 1,
                total: 0,
            },
            treeOption: {
                nodeKey: "id",
                lazy: true,
                treeLoad: function (node, resolve) {
                    const parentId = node.level === 0 ? 0 : node.data.id;
                    console.log(parentId)
                    console.log(resolve)
                    // getDeptLazyTree(parentId).then((res) => {
                    //   resolve(
                    //     res.data.data.map((item) => {
                    //       return {
                    //         ...item,
                    //         leaf: !item.hasChildren,
                    //       };
                    //     })
                    //   );
                    // });
                },
                addBtn: false,
                menu: false,
                size: "small",
                props: {
                    labelText: "标题",
                    label: "title",
                    value: "value",
                    children: "children",
                },
            },
            option: {
                labelWidth: 120,
                viewLabelWidth: 100,
                searchlabelWidth: 100,
                // height: "auto",
                height: 600,
                calcHeight: 30,
                align: "center",
                headerAlign: "center",
                lazy: true,
                tip: false,
                simplePage: true,
                searchShow: true,
                searchMenuSpan: 6,
                tree: true,
                border: true,
                index: true,
                selection: true,
                viewBtn: false,
                viewTitle: "测站导入",
                editBtn: false,
                delBtn: false,
                addBtn: false,
                menuWidth: 220,
                dialogType: "drawer",
                dialogClickModal: false,
                column: [
                    {
                        label: "项目名称",
                        prop: "projectName",
                        search: true,
                        span: 12,
                    },
                    {
                        label: "所属机构",
                        prop: "orgId",
                        span: 12,
                        hide: true,
                        viewDisplay: false,


                        dicData: [],
                        type: "tree",

                        addDisabled: false,
                        props: {
                            label: "title",
                        },
                        rules: [
                            {
                                required: false,
                                message: "请选择机构",
                                trigger: "click",
                            },
                        ],
                    },
                    {
                        label: "所属机构",
                        prop: "orgName",
                        span: 12,
                        editDisplay: false,
                        addDisplay: false,
                    },

                    {
                        label: "导入时间",
                        prop: "importTime",
                        span: 8,

                    },

                ],
            },
            data: [],
        };
    },
    computed: {
        // ...mapGetters(["userInfo", "permission"]),
        permissionList() {
            return {
                // addBtn: this.vaildData(this.permission.docCategory_add, false),
                // viewBtn: this.vaildData(this.permission.docCategory_view, false),
                // delBtn: this.vaildData(this.permission.docCategory_delete, false),
                // editBtn: this.vaildData(this.permission.docCategory_edit, false),
            };
        },
        ids() {
            let ids = [];
            this.selectionList.forEach((ele) => {
                ids.push(ele.id);
            });
            return ids.join(",");
        },
    },
    mounted() { },
    created() {
        this.initData();
    },
    methods: {
        handleRemove(file, fileList) {
            this.$message.warning("超出文件上传数量{}{}", file, fileList);
            //this.ruleForm.attach = "";
        },
        onExceed(file, fileList) {
            this.$message.warning("超出文件上传数量{}{}", file, fileList);

        },
        uploadUrl: function () {
            return `/api/galaxy-test/data/manage/import/rtu?${this.website.tokenHeader
                }=${getToken()}`;
        },
        beforeUpload() {
            this.loading = true;
        },
        uploadSuccess(response, file, fileList) {
            console.log("---response:", response);
            console.log("---file:", file);

            console.log("---fileList:", fileList);
            this.fileList = [];
            this.loading = false;
            this.$message.success("导入成功");
            this.changeDate();
        },
        initData() {
            getDeptTree('000000').then((res) => {
                const column = this.findObject(this.option.column, "orgId");
                column.dicData = res.data.data;
            });
        },

        rtuImport(item) {
            //this.$message.de("11111111111"+item.id);
            // this.$message.log("11111111111"+item.projectName);

            //  this.$message({
            //           type: "success",
            //           message: "操作成功!"+item.projectName,
            //         });

            this.projectName = item.projectName;
            this.projectId = item.id;
            this.rtuImportProcessDialog = true;
        },

        // openInfo(item) {
        //   this.id = item.id;
        //   this.infoDialog = true;
        //   this.$nextTick(() => {
        //     this.$refs["warningInfo"].init();
        //   });
        // },
        // openOrder(item) {
        //   this.id = item.id;
        //   this.orderDialog = true;
        //   this.$nextTick(() => {
        //     this.$refs["maintainOrder"].init();
        //   });
        // },

        rowSave(row, done, loading) {
            add(row).then(
                () => {
                    this.onLoad(this.page);
                    this.$message({
                        type: "success",
                        message: "操作成功!",
                    });
                    done();
                },
                (error) => {
                    window.console.log(error);
                    loading();
                }
            );
        },
        rowUpdate(row, index, done, loading) {
            update(row).then(
                () => {
                    this.onLoad(this.page);
                    this.$message({
                        type: "success",
                        message: "操作成功!",
                    });
                    done();
                },
                (error) => {
                    window.console.log(error);
                    loading();
                }
            );
        },
        rowDel(row) {
            this.$confirm("确定将选择数据删除?", {
                confirmButtonText: "确定",
                cancelButtonText: "取消",
                type: "warning",
            })
                .then(() => {
                    return remove(row.id);
                })
                .then(() => {
                    this.onLoad(this.page);
                    this.$message({
                        type: "success",
                        message: "操作成功!",
                    });
                });
        },
        searchReset() {
            this.query = {};
            this.onLoad(this.page);
        },
        searchChange(params, done) {
            this.query = params;
            this.page.currentPage = 1;
            this.onLoad(this.page, params);
            done();
        },
        selectionChange(list) {
            this.selectionList = list;
        },
        selectionClear() {
            this.selectionList = [];
            this.$refs.crud.toggleSelection();
        },
        handleDelete() {
            if (this.selectionList.length === 0) {
                this.$message.warning("请选择至少一条数据");
                return;
            }
            this.$confirm("确定将选择数据删除?", {
                confirmButtonText: "确定",
                cancelButtonText: "取消",
                type: "warning",
            })
                .then(() => {
                    return remove(this.ids);
                })
                .then(() => {
                    this.onLoad(this.page);
                    this.$message({
                        type: "success",
                        message: "操作成功!",
                    });
                    this.$refs.crud.toggleSelection();
                });
        },
        beforeOpen(done, type) {


            // if (["add", "edit"].includes(type)) {
            //     this.initData();
            //   }
            if (["edit", "view"].includes(type)) {
                getDetail(this.form.id).then((res) => {
                    this.form = res.data.data;
                });
            }
            done();
        },
        currentChange(currentPage) {
            this.page.currentPage = currentPage;
        },
        sizeChange(pageSize) {
            this.page.pageSize = pageSize;
        },
        refreshChange() {
            this.onLoad(this.page, this.query);
        },
        onLoad(page, params = {}) {
            this.loading = true;
            getPage(
                page.currentPage,
                page.pageSize,
                Object.assign(params, this.query)
            ).then((res) => {
                const data = res.data.data;
                this.page.total = data.total;
                this.data = data.records;
                this.loading = false;
                this.selectionClear();
            });
        },
    },
};
</script>
